particle
	parent_type = /obj
	bound_width = 1
	bound_height = 1

	New(x,y,z,duration)
		setPos(x,y,z)
		Live(duration)

	Step(dir,dist=move_speed,face=0)
		if(z)
			var/mx = 0, my = 0
			if(dir&EAST)
				mx += dist
			if(dir&WEST)
				mx -= dist
			if(dir&NORTH)
				my += dist
			if(dir&SOUTH)
				my -= dist
			setPos(gx+mx,gy+my,z,face||dir)
		return 1

	Offset(x,y,Dir)
		if(z)
			setPos(gx+x,gy+y,z,Dir)
		return 1

	Project(ang,dist,Dir)
		if(z)
			setPos(gx+cos(ang),gy+sin(ang),z,Dir)
		return 1

	Move(NewLoc,Dir,Step_x,Step_y)
		setPos(gx+NewLoc,gy+Dir,z,Step_x)
		return 1

	Teleport(nx,ny,nz,Dir=0)
		setPos(nx,ny,nz,Dir)
		return 1

	proc
		Live(lifetime)
			set waitfor = 0
			sleep(lifetime)
			loc = null

	angled
		New(x,y,z,duration,ang)
			transform = matrix(transform,-ang,MATRIX_ROTATE|MATRIX_MODIFY)
			setPos(x,y,z)
			Live(duration)

	projectile
		New(x,y,z,duration,ang,dist)
			var/ox = pixel_x+dist*cos(ang), oy = pixel_y+dist*sin(ang)
			setPos(x,y,z)
			animate(src,pixel_x=ox,pixel_y=oy,time=duration)
			Live(duration)